/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include <project.h>
#include <xl362.h>

#define DUMMY (uint8)0xFF

uint8 SingleByteRead(uint8 Address)
{
    uint8 i;
    uint8 ReadBufferSize=0;
    uint8 ReadByte[3];
    uint8 ReadArray[3];
    
    /*Read command for ADXL362*/
    ReadArray[0]=XL362_REG_READ; 
    /*Read Address for ADXL362*/
    ReadArray[1]=Address;
    /*Excess byte to generate clock raeding sent byte from ADXL362*/
    ReadArray[2]=DUMMY;
    
            SPI_Master_SpiUartPutArray(ReadArray,3);            
            while(SPI_Master_SpiUartGetRxBufferSize()!=3)
            {
            }    
            
            ReadBufferSize=(uint8)SPI_Master_SpiUartGetRxBufferSize();
            
            for(i=0;i<ReadBufferSize;i++)
            {
                ReadByte[i]=(uint8)SPI_Master_SpiUartReadRxData();
            }
            SPI_Master_SpiUartClearRxBuffer();
            
            return(ReadByte[2]);
}

void SingleByteWrite(uint8 Address,uint8 Byte)
{
    uint8 WriteArray[3];
    
    /*Command to write in ADXL362*/
    WriteArray[0]=XL362_REG_WRITE; 
    /*Write to Address in ADXL362*/
    WriteArray[1]=Address;
    /*Data to be written to address in ADXL362*/
    WriteArray[2]=Byte;
    
            SPI_Master_SpiUartPutArray(WriteArray,3);            
            while(SPI_Master_SpiUartGetRxBufferSize()!=3)
            {
            }    
            
            SPI_Master_SpiUartClearRxBuffer();

}

/*
Device Configuration:
This section outlines the procedure for configuring the device
and acquiring data. In general, the procedure follows the sequence
*/
void ADXL362config(void)
{
    SingleByteWrite(XL362_THRESH_ACTL,DUMMY);
    SingleByteWrite(XL362_THRESH_ACTH,DUMMY);
    SingleByteWrite(XL362_TIME_ACT,DUMMY);
    SingleByteWrite(XL362_THRESH_INACTL,DUMMY);
    SingleByteWrite(XL362_THRESH_INACTH,DUMMY);
    SingleByteWrite(XL362_TIME_INACTL,DUMMY);
    SingleByteWrite(XL362_TIME_INACTH,DUMMY);
    SingleByteWrite(XL362_ACT_INACT_CTL,DUMMY);
    SingleByteWrite(XL362_FIFO_CONTROL,DUMMY);
    SingleByteWrite(XL362_FIFO_SAMPLES,DUMMY);
    SingleByteWrite(XL362_INTMAP1,DUMMY);
    SingleByteWrite(XL362_INTMAP2,DUMMY);
    SingleByteWrite(XL362_FILTER_CTL,DUMMY);
    SingleByteWrite(XL362_POWER_CTL,DUMMY);
}

/*
Start-up Routine:
This routine assumes a ±2 g measurement range and operation
in wake-up mode.
*/
void StartupRoutine_initADXL362(void)
{
    SingleByteWrite(XL362_THRESH_ACTL,0xFA);    
    SingleByteWrite(XL362_THRESH_ACTH,0);
    
    SingleByteWrite(XL362_THRESH_INACTL,0x96);
    SingleByteWrite(XL362_THRESH_INACTH,0);
    
    SingleByteWrite(XL362_TIME_INACTL,0x1E);

    SingleByteWrite(XL362_ACT_INACT_CTL,0x3F);
    
    SingleByteWrite(XL362_INTMAP2,0x40);
    
    SingleByteWrite(XL362_POWER_CTL,0x0A);
}



/* [] END OF FILE */
