/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include <project.h>
#include <stdlib.h>
#include <xl362.h>
#include <Accelerometer.h>

int main()
{      
    int16 Received_Xdata=ZERO;
    int16 Received_Ydata=ZERO;
    int16 Received_Zdata=ZERO;
    

    
    SPI_Master_Start();
    
    SingleByteWrite(XL362_SOFT_RESET,0x52);
    /* A latency of approximately 0.5 ms is required after soft reset */
    CyDelayUs(500);
    StartupRoutine_initADXL362();
    
    /* Place your initialization/startup code here (e.g. MyInst_Start()) */

    CyGlobalIntEnable;  /* Uncomment this line to enable global interrupts. */
    
    SW_Tx_UART_1_Start();
    SW_Tx_UART_1_PutString("     X      Y      Z");
    SW_Tx_UART_1_PutCRLF();

    for(;;)
    {
        /* Place your application code here. */        
        
        Received_Xdata=ReadXaxis();        
        Received_Ydata=ReadYaxis();        
        Received_Zdata=ReadZaxis();
        
        if(ADXL_INT2_Read()==1)
        {
            AwakeStatus_Write(1);
        }
        else
        {
            AwakeStatus_Write(0);
        }
       
        CyDelay(100);                
        
        IntToAsciiTx(Received_Xdata);        
        SW_Tx_UART_1_PutChar(' ');
        IntToAsciiTx(Received_Ydata);
        SW_Tx_UART_1_PutChar(' ');
        IntToAsciiTx(Received_Zdata);  
        
        SW_Tx_UART_1_PutChar(0x0D);           //(\r=0x0D) (carriage return) Moves the active position to the initial position of the current line.
                                     
    }
}


void IntToAsciiTx(int16 Hex)
{   
    uint8 i;
    uint8 Digit[6];
    
    /*(Condition)?(ASCII value for '+'):(ASCII value for '-');*/
    (Hex<0)?(Digit[ZERO]=0x2D):(Digit[ZERO]=0x2B);     
    Hex=abs(Hex);
    
    Digit[1]=((Hex/10000)%10)+'0';          /* Ten Thousand place digit*/
    Digit[2]=((Hex/1000)%10)+'0';           /* Thousand place digit*/
    Digit[3]=((Hex/100)%10)+'0';            /* Hundred place digit*/   
    Digit[4]=((Hex/10)%10)+'0';             /* Ten place digit*/
    Digit[5]=((Hex/1)%10)+'0';              /* Unit place digit*/
    
    for(i=0;i<sizeof(Digit);i++)
    {
        SW_Tx_UART_1_PutArray(&Digit[i],1);
    }
}

/* [] END OF FILE */        
